class LSystemClass{
  String axiom = "FFFFFFFFX";
  
  String [][] KochRules = { {"F","F-F++F-F"},
                        {"+","+"},
                        {"-","-"},
                        {"[","["},
                        {"]","]"}};
  String [][] BushRules = { {"F","F[+F]F[-F]F"},
                        {"+","+"},
                        {"-","-"},
                        {"[","["},
                        {"]","]"}};
  String [][]TreeRules = { {"F","FF", "FF", "FFF","F"},
                        {"X","F[+X][-X]","F[+X][-X]", "F[+X][-X][FX]","[+X][-X]"},
                        {"+","+","+","+","+"},
                        {"-","-","-","-","-"},
                        {"[","[","[","[","["},
                        {"]","]","]","]","]"}};
  String [][] lavenderRules = { {"F","FF"},
                        {"X","[+FX][-FX][FX]"},
                        {"+","+"},
                        {"-","-"},
                        {"[","["},
                        {"]","]"}};
                        //axiom = "X"
  String [][] juniperRules = { {"F","F","F[--FFFF]F","F[++FFFFF]F","F[++FF]F[--FFFFF]","FF"},
                        {"X","F[+X][-X]F[-X]FFX","F[+X]F[-X][+X]F[+X]FX","F[-FX][+X]F[+X]F[-X]FFX","F[+FX]F[-X]F[+X][-X]F[-X]FFX","F[+FX]F[-FX]F[+X]F[-X]FFX"},
                        {"+","+","+","+","+","+"},
                        {"-","-","-","-","-","-"},
                        {"[","[","[","[","[","["},
                        {"]","]","]","]","]","]"}};
                        //axiom = "[----Y][---Y][--Y][-Y][Y][+Y][++Y][+++Y][++++Y]"
  String [][] juniperBushrules = { {"F","F","F[--FFFF]F","F[++FFFFF]F","F[++FF]F[--FFFFF]","FF"},
                        {"X","F[+X][-X]F[-X]FFX","F[+X]F[-X][+X]F[+X]FX","F[-FX][+X]F[+X]F[-X]FFX","F[+FX]F[-X]F[+X][-X]F[-X]FFX","F[+FX]F[-FX]F[+X]F[-X]FFX"},
                        {"Y","X","X","X","X","X"},
                        {"+","+","+","+","+","+"},
                        {"-","-","-","-","-","-"},
                        {"[","[","[","[","[","["},
                        {"]","]","]","]","]","]"}};
                        //set angle=120
  String [][] SerpinskiTriangleRules = { {"F","FF"},
                        {"X","[+FX][++FX][+++FX]"},
                        {"+","+"},
                        {"-","-"},
                        {"[","["},
                        {"]","]"}};
                        //axiom ="FFFFFFFFX"
                        // f=t.forward(size/2)
                        //angle=10
  String [][] rules = { {"F","FFF","FFF","FF","FFFF"},
                        {"X","F[t+++Y[----Y-Y-Y-YY-Y]-Y-Y-Y-[----Y-Y-Y-Y]YY-Y-Y][T--Z+Z+Z[+++Z+ZZ+Z+]+ZZ+Z+Z+Z]F[t++Y[-Y[-YY-Y-Y]-Y-YY-Y-Y-YY-Y-Y]f[T--Z[+Z+Z+ZZ+Z]+ZZ+ZZ+ZZ]F[t+Y[-YY-Y]-Y-YY-Y-Y]f[T-Z+Z+ZZ+Z+Z]F[t+YY-YY-Y]f[T-Z+ZZZ+Z]F[tYY-YY-Y]f[TZ+ZZ+Z]F[t-YYY-Y][T-Z+Z+Z+Z]F[t-YY-Y]f[T+Z+ZZ]F[t--Y-Y]f[T++Z][+F]F",
                             "F[t+++Y-Y-YY[++Y-Y-Y-Y]-Y-Y-Y-Y]f[T--Z[++Z+Z+Z]+ZZ+Z+Z[+++Z+Z+ZZ]+Z+Z+Z]F[t++Y[-Y-Y-Y-Y]-YY-Y-Y-Y-Y]f[T-Z+Z+Z+ZZ+ZZ]F[t++Y-Y-Y-Y-Y-Y]f[T-Z+Z+ZZ+Z+Z]F[t+Y-Y-YY-Y][T-Z+ZZ+Z+Z]F[tY-YY-Y]f[TZZ+Z+Z+Z]F[tYY-Y-Y]f[T+ZZ+ZZ]F[t-Y-YY]f[T-ZZ+Z]F[t--Y-Y][T+Z+Z][-F][+F]",
                             "F[t+++Y-Y[---Y-Y-YY]-Y-Y-YY-Y-Y]f[T--Z[--Z+Z+ZZ]+Z+Z+Z+Z[+++Z+Z+Z]Z+Z+Z]F[t++Y-Y[-Y-Y-Y]-Y-Y-Y-Y-Y]f[T--Z+Z[+Z+Z+ZZ+Z]+ZZ+ZZ+Z]F[t+Y-Y-Y-Y-Y-Y][T-Z+Z+ZZ+Z+Z]F[t+Y-Y-Y-Y-Y]f[T-Z+ZZ+Z+Z]F[tY-YYY-Y]f[TZZ+ZZ]F[t-YY-Y]f[T+Z+Z+Z+Z]F[tYY-Y][T-Z+ZZ]F[t--Y][T++Z]f[-Y][+F+F]",
                             "F[t+++Y-YY-Y-Y[---Y-Y-Y]-Y-Y-Y]f[T---Z+Z[++++ZZ+Z+Z]+ZZ+Z+Z[++ZZ+Z+Z]+Z+Z]F[t++Y[Y-Y-Y-Y]-Y-Y-Y-Y-YY][T-Z+Z+ZZ+Z+Z+Z]F[t++Y-Y-Y-Y-Y-Y]f[T-Z+Z+Z+ZZ+Z]F[t+Y-Y-Y-Y-Y]f[T-Z+Z+Z+Z+Z]F[tY-YY-Y][TZ+Z+Z+Z+Z]F[tYY-YY]f[TZZ+Z+Z]F[t-Y-YY]f[T+ZZ+Z]F[t--Y]f[T++Z][-F-F]"},
                        {"Y","F[+++Y-Y-YY][--YY-YY]Y",
                             "FFF[---Y-YY-YYYY][++ Y-YYYY-Y-YY]YY",
                             "FFF[---Y]F[++YY]YY",
                             "FFF[---Y-YY-YY]FF[++Y-Y-YY]YY"},
                        {"Z","F[+++Z+Z+ZZ][--ZZ+ZZ+ZZ]ZZ",
                             "FFF[---Z+ZZ+ZZZ][++Z+ZZZ+Z+ZZ]ZZ",
                             "FFF[---Z]F[++ZZ]ZZZ",
                             "FFF[---Z+ZZ+ZZ]FF[++Z+Z+ZZ]ZZ"},
                        {"+","+","+","+","+"},
                        {"t","t","t","t","t"},
                        {"T","T","T","T","T"},
                        {"f","f","f","f","f"},
                        {"-","-","-","-","-"},
                        {"[","[","[","[","["},
                        {"]","]","]","]","]"}};
                        //angle =~90, use all random
    String [][] FernRules = { {"F","FFF"},
                        {"A","AAA"},
                        {"B","BBB"},
                        {"C","CCC"},
                        {"D","DDD"},
                        {"E","EEE"},
                        {"G","GGG"},
                        {"H","HHH"},
                        {"I","III"},
                        {"J","JJJ"},
                        {"X","F[+X]F[-X]A[+a]A[-a]B[+b]B[-b]C[+c]C[-c]D[+d]D[-d]E[+e]E[-e]G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"a","A[+a]A[-a]B[+b]B[-b]C[+c]C[-c]D[+d]D[-d]E[+e]E[-e]G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"b","B[+b]B[-b]C[+c]C[-c]D[+d]D[-d]E[+e]E[-e]G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"c","C[+c]C[-c]D[+d]D[-d]E[+e]E[-e]G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"d","D[+d]D[-d]E[+e]E[-e]G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"e","E[+e]E[-e]G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"g","G[+g]G[-g]H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"h","H[+h]H[-h]I[+i]I[-i]J[+j]J[-j]J"},
                        {"i","I[+i]I[-i]J[+j]J[-j]J"},
                        {"j","J[+j]J[-j]J"},
                        {"+","+"},
                        {"-","-"},
                        {"[","["},
                        {"]","]"}};
                        
                     
                        
  String computedWord;
  int iterations;
  float size, angle, scaleFactor;
  
  LSystemClass (float size, float angle, float scaleFactor) {
    this.size = size;
    this.angle = angle;
    this.scaleFactor = scaleFactor;
    computedWord = axiom;
    iterations = 0;
  }
  
  void iteration() { 
      char s;
      String newWord = "";
      size = size*scaleFactor;
      //loop through computedWord
      for (int i = 0; i<computedWord.length();i++){
        //for every symbol
        s = computedWord.charAt(i);
        //loop through rules to find a match
        for (int j=0; j<rules.length;j++){
          if(s == rules[j][0].charAt(0)){
            //newWord = newWord + rules[j][1]; //replacement
            newWord = newWord + rules[j][(int)random(1,5)];
            break;
        }
      }
    }
    iterations ++;
    computedWord = newWord;
    println(iterations +": " +computedWord);

  }
 
  
  void drawLSystem (Turtle t){
    char s;
    for(int i=0;i<computedWord.length();i++){
      s = computedWord.charAt(i);
      if(s=='F'){
        //t.right(random(-2,2));
        t.forward(size);
      }
      else if (s=='+')
        //t.right(angle);
        t.right(angle + (random(-5.0,5.0)));
      else if (s=='-')
        //t.left(angle);
        t.left(angle + (random(-5.0,5.0)));
      else if (s=='[')
        t.push();
      else if (s==']')
        t.pop();
      else if (s=='t')
        t.right(90);
      else if (s=='T')
        t.left(90);
      else if (s=='f')
        t.forward(size/2);
      else if (s=='A'){
        t.right(random(-2,2));
        t.forward(.9*size);
      }
      else if (s=='B'){
        t.right(random(-2,2));
        t.forward(.8*size);
      }
      else if (s=='C'){
        t.right(random(-2,2));
        t.forward(.7*size);
      }
      else if (s=='D'){
        t.right(random(-2,2));
        t.forward(.6*size);
      }
      else if (s=='E'){
        t.right(random(-2,2));
        t.forward(.5*size);
      }
      else if (s=='G'){
        t.right(random(-2,2));
        t.forward(.4*size);
      }
      else if (s=='H'){
        t.right(random(-2,2));
        t.forward(.3*size);
      }
      else if (s=='I'){
        t.right(random(-2,2));
        t.forward(.2*size);
      }
      else if (s=='J'){
        t.right(random(-2,2));
        t.forward(.1*size);
      }
    }
  }
}
