//Large Assignment 1: LSystems
//Name: Camila Friedman-Gerlicz
//E-mailfriedmangerlicz99@unm.edu
//Course: CS 591 Computational Fabrication
//Submitted: 9/14/23

//This program impliments various L-systems that mimic the beahvior of various plants.
//The size, angle and scale need to be adjusted for different programs. 
//Certain L-systems are designed for random movement and others are not. 



import processing.pdf.*;
import Turtle.*;
LSystemClass l;
Turtle t;
boolean record;

void setup(){
  size(900,900);
  background(#81106E);
  stroke(255);
  l = new LSystemClass(height/2,10,.15);
  t = new Turtle(this);
  frameRate(1);
  //beginRecord(PDF,"LsystemPDF" + random(0,100) + ".pdf");
}

void draw(){
  //if (record){
  //   beginRecord(PDF,"LsystemPDF" + random(0,100) + ".pdf");
  //}
  t.setX(width/2);
  t.setY(height*.8);
  background(#81106E);
  l.drawLSystem(t);
  l.iteration();
  //if (record) {
    //endRecord();
    //record = false;
  //} 
}

void keyPressed(){
  if (key==' '){
    String filename = "Lsystem" + random(0,100) + ".png";
    save(filename);
    println("saved file: " +filename);
  }
  if (key=='p'){
    //record = true;
    endRecord();
  }
}


 
